<template>
    <MdDialogPrompt
            style="z-index: 100"
            :md-active="active"
            :md-title="$store.state.modals.prompt && $store.state.modals.prompt.title"
            :md-content="$store.state.modals.prompt && $store.state.modals.prompt.message"
            :md-confirm-text="$store.state.modals.prompt && $store.state.modals.prompt.okText"
            :md-cancel-text="$store.state.modals.prompt && $store.state.modals.prompt.cancelText"
            @md-confirm="confirm()"
            @md-cancel="cancel()"
            v-model="value"
            md-input-name="prompt"
    />
</template>
<script>
  /* eslint-disable no-debugger */
  import Vue from 'vue';
  import jsLog from 'js-logger';
  import { MdDialogPrompt } from 'vue-material/dist/components'

  const log = jsLog.get('modals');

  Vue.use(MdDialogPrompt);

  export default {
    computed: {
      active() {
        const active = this.$store.state.modals.prompt && !!this.$store.state.modals.prompt.message;
        return active;
      }
    },
    data() {
      return {
        value: null
      };
    },
    methods: {
      async close(ok, logText) {
        log.info(logText);
        const { resolve } = this.$store.state.modals.prompt;
        this.$store.dispatch('modalsClose');
        await this.$nextTick();
        resolve(ok && this.value);
        this.value = undefined;
      },
      confirm() {
        this.close(true, `prompted ${this.value}`);
      },
      async cancel() {
        this.close(false, 'prompt cancelled');
      }
    }
  }
</script>
<style>

</style>
